package dev.laika.login.ws;

import javax.xml.ws.BindingProvider;
import javax.xml.ws.handler.Handler;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public abstract class WebserviceCaller {

	private WebserviceCaller() {
		// Do nothing because it is to protect
	}

	@SafeVarargs
	public static void configureService(Object object, String url, SOAPHandler<SOAPMessageContext>... soapHandler) {
		BindingProvider bindingProvider = (BindingProvider) object;
		bindingProvider.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, url);
		bindingProvider.getRequestContext().put("javax.xml.ws.client.connectionTimeout", 60000);
		bindingProvider.getRequestContext().put("javax.xml.ws.client.receiveTimeout", 180000);
		if (soapHandler != null) {
			List<Handler> handlers = new ArrayList<>();
			Collections.addAll(handlers, soapHandler);
			bindingProvider.getBinding().setHandlerChain(handlers);
		}
	}
}
